var gProgramProgressBar = null;
var gReStreamPlayer = null;
var gCurrentChannel = null;
var gProgramGuideQueue = new Array();
var lSearchTimeOut = null;

xajax.callback.global.onRequest  = function(){jQuery("#loading").show();};
xajax.callback.global.onComplete = function(){jQuery("#loading").hide();};

function getUrlParam(name) {
	name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	var regexS = "[\\?&]"+name+"=([^&#]*)";
	var regex = new RegExp( regexS );
	var results = regex.exec( window.location.href );
	if( results == null )
		return "";
	else
		return decodeURIComponent(results[1].replace(/\+/g, " "));
}

function loadReStream() {
	jQuery('#ProgramProgress').progressbar({value: 0});
	jQuery('#message').html('<p>Loading ReStream</p>');
	jQuery('#message').dialog({modal: true,closeOnEscape: false});
	xajax_action('loadReStream','start');
}

function loadChannelList() {
	var lExtraHeight = 0;
	if (jQuery('#List h3').length > 13) lExtraHeight = 50;
	jQuery('#List').height(jQuery('#PlayerWrapper').height() + lExtraHeight);
	jQuery('#List').accordion({fillSpace: true});
}

function loadProgramGuide() {
	jQuery('#List ul').each(function(i) {
		var lTotal = jQuery(this).children('li').length;
		var lProgressBar = jQuery(this).parent().prev('h3').children('.progress');
		lProgressBar.attr('id','channelProgressBar' + i);
		if (lTotal > 0) {
			jQuery('#channelProgressBar' + i).attr('title','0% done');
			jQuery('#channelProgressBar' + i).progressbar({value: 0 });
			jQuery(this).children('li').each(function(j) {
				gProgramGuideQueue.push(new Array(jQuery(this).attr('id'),'#channelProgressBar' + i,lTotal,j));
			});
		} else {
			jQuery('#channelProgressBar' + i).attr('title','100% done');
			jQuery('#channelProgressBar' + i).progressbar({value: 100 });
		}
	});
	nextChannel();
}

function nextChannel() {
	if (gProgramGuideQueue.length > 0) {
		var lChannelID = gProgramGuideQueue.shift();
		var lPercentage = Math.ceil((lChannelID[3]+1) / lChannelID[2] * 100);
		jQuery(lChannelID[1]).attr('title',lPercentage + '% done');
		jQuery(lChannelID[1]).progressbar({value: lPercentage });
		xajax_action('loadProgramGuide',lChannelID[0]);
	}
}

function startProgramProgressBar(pStart,pEnd,pChannel) {
	var lDuration = pEnd - pStart; // In seconds
	var lTimeout = Math.round(lDuration / 100);
	var lCurrentPercentage = Math.round(((new Date().getTime()/1000) - pStart) / lDuration * 100);
	if (gProgramProgressBar != null) clearTimeout(gProgramProgressBar);
	if (pStart == 0 && pEnd == 0) {
		jQuery('#ProgramProgress').attr('title','Unknown duration');
		jQuery('#ProgramProgress').progressbar({value: 0});
	} else {
		updateProgramProgressBar(lCurrentPercentage,lTimeout * 1000,pChannel);
	}
}

function updateProgramProgressBar(pCurrentPercentage,pTimeout,pChannel) {
	jQuery('#ProgramProgress').attr('title',pCurrentPercentage + '% done');
	jQuery('#ProgramProgress').progressbar({value: pCurrentPercentage++});
	if (pCurrentPercentage > 100) {
		if (gProgramProgressBar != null) clearTimeout(gProgramProgressBar);
		setTimeout(function(){xajax_action('currentProgram',pChannel.replace("'","\'"));},30000);
	} else {
		gProgramProgressBar = setTimeout(function(){updateProgramProgressBar(pCurrentPercentage,pTimeout,pChannel);},pTimeout);
	}
}

function zapTo(pChannelID,pChannelName) {
	gReStreamPlayer.sendEvent('STOP','true');
	jQuery('#message').html('<p>Zapping to channel <strong>' + pChannelName + '<strong></p>');
	jQuery('#message').dialog({modal: true,closeOnEscape: false, width: '300px'});
	xajax_action('currentProgram',pChannelID.replace("'","\'"));
	xajax_action('watch',pChannelID.replace("'","\'"));
}

function VLCStatus() {
	xajax_action('VLCStatus');
	setTimeout(function() { VLCStatus();},30000); // Twice a minute
}

function scrollToCurrentProgram(pChannelID) {
	xajax_action('currentProgram',pChannelID.replace("'","\'"));
	var lCurrentProgram = jQuery("li[class~='current']");
	if (lCurrentProgram != null && lCurrentProgram.attr('id') == pChannelID) return;
	var lScrollToProgram = jQuery("li[id*='" + pChannelID.replace("'","\\'") + "']");
	if (lScrollToProgram == null) return;
	jQuery('li').removeClass('current');
	lScrollToProgram.parent().parent().prev('h3').click();// Open the right boutique menu
	lScrollToProgram.addClass('current');

	setTimeout(function(){
		if (jQuery('.ui-accordion-content-active') != null) {
			var lPos = lScrollToProgram.offset();
			var lTopPos = jQuery('.ui-accordion-content-active').position();
			var lDistance = Math.round(lPos.top-(lTopPos.top+67)); // Design flaw.... don't know why...?
			jQuery('.ui-accordion-content-active').stop().scrollTo({top: '+=' + lDistance,left:0},900);
		}
	},1000);
}

function search(pValue) {
	if (pValue.length >= 3) {
		clearTimeout(lSearchTimeOut);
		lSearchTimeOut = setTimeout(function(){
			jQuery('#result li').remove();
			var re = new RegExp(pValue, 'ig');
			var noResults = true;
			jQuery('#List li').each(function(i){
				if (jQuery(this).text().match(re)) {
					noResults = false;
					jQuery('#result').append(jQuery(this).clone());
				}
			});
			if (noResults) {
				jQuery('#result').append('<li style=\"text-align: center; font-weight: bold;\">No Results</li>');
			}
		},1500);
	}
}

function playerReady(thePlayer) {
	gReStreamPlayer = document.getElementById(thePlayer.id);
}

function loadReStreamPlayer() {    
    if (getUrlParam('debug') == 1) {
    	jwplayer("ReStreamPlayer").setup({
	        autostart: false,
	        image: 'images/dreambox.jpg',
	        file: 'jwplayer/empty.mp4',
	        flashplayer: "jwplayer/player.swf",
	        skin: "jwplayer/glow.zip",
	        volume: 80,
	        width: '100%',
	        height: '100%',
	        plugins: 'qualitymonitor-2',
	        controlbar: 'bottom',
			wmode: 'transparent'
	    });
    } else {
    	jwplayer("ReStreamPlayer").setup({
	        autostart: false,
	        image: 'images/dreambox.jpg',
	        file: 'jwplayer/empty.mp4',
	        flashplayer: "jwplayer/player.swf",
	        skin: "jwplayer/glow.zip",
	        volume: 80,
	        width: '100%',
	        height: '100%',
	        controlbar: 'bottom',
			wmode: 'transparent'
	    });
    }
}

jQuery(document).ready(function() {
	loadChannelList();
	loadReStream();
});